<?php
include 'individual-payment-header.php';
$configData = configItem();
?>
<!DOCTYPE html>
<html>

<head>
    <title>Pay Page</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script src="../assets/js/jquery-3.3.1.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" href="../assets/css/custom.css" type="text/css">
</head>

<body>
    <div class="d-flex justify-content-center">
        <div class="lw-page-loader lw-show-till-loading">
            <div class="spinner-border" role="status"></div>
        </div>
    </div>

    <div class="pt-4 mb-5 container" id="lwCheckoutForm">
        <div class="row">
            <div class="col-md-4 lw-logo-section mt-0">
                <!-- Payment page logo -->
                <div class="lw-logo-container">
                    <img class="lw-logo" src="../assets/imgs/logo-for-site.png">
                </div>
                <!-- /Payment page logo -->
                <!-- Payment Page Other Information -->
                <h5>PHP ready to use Payment Gateway Integrations</h5>
                <hr class="mb-4">
                <h6>Ready to use </h6>
                <h6>Easy Integration</h6>
                <h6>Many Gateways</h6>
                <h6>Well Documented</h6>
                <!-- Payment Page Other Information -->
                <hr class="mb-4">
                <a href="<?= getAppUrl() ?>" class="btn btn-secondary">Go Back</a>
            </div>
            <div class="col-lg-8">
                <form method="post" id="lwPaymentForm">
                    <div class="card">
                        <!-- Payment Page header -->
                        <div class="card-header">
                            <h3 class="text-center">Complete your payment</h3>
                        </div>
                        <!-- /Payment Page header -->
                        <div class="card-body">
                            <!-- Info Message -->
                            <div class="alert alert-info">
                                This is just an example, you can integrate these payment gateway easily using this example implementation.
                            </div>
                            <!-- Info Message -->
                            <!-- show validation message block -->
                            <div id="lwValidationMessage" class="lw-validation-message"></div>
                            <!-- / show validation message block -->
                            <?php
                            // Get config data
                            $configData = configItem();
                            $userDetails = [
                                'amounts' => [ // at least one currency amount is required
                                    'USD'   => 100,
                                    'INR'   => 170,
                                    'NGN'   => 120,
                                    'TRY'   => 180,
                                    'EUR'   => 9.05
                                ],
                                'order_id'      => 'ORDS' . uniqid(), // required in instamojo, Iyzico, Paypal, Paytm gateways
                                'customer_id'   => 'CUSTOMER' . uniqid(), // required in Iyzico, Paytm gateways
                                'item_name'     => 'Sample Product', // required in Paypal gateways
                                'item_id'       => 'ITEM' . uniqid(), // required in Iyzico, Paytm gateways
                                'item_qty'      => 1,
                                'payer_email'   => 'sample@domain.com', // required in instamojo, Iyzico, Stripe gateways
                                'payer_name'    => 'John Doe', // required in instamojo, Iyzico gateways
                                'payer_mobile'  => '9999999999',
                                'description'   => 'Lorem ipsum dolor sit amet, constetur adipisicing', // Required for stripe
                                'ip_address'    => getUserIpAddr(), // required only for iyzico
                                'address'       => '3234 Godfrey Street Tigard, OR 97223', // required in Iyzico gateways
                                'city'          => 'Tigard',  // required in Iyzico gateways
                                'country'       => 'United States' // required in Iyzico gateways
                            ];
                            ?>
                            <ul class="list-group mb-4">
                                <li class="list-group-item">
                                    <h3>Customer Details</h3>
                                </li>
                                <li class="list-group-item">
                                    <strong>Name:</strong> <?= $userDetails['payer_name'] ?>
                                </li>
                                <li class="list-group-item">
                                    <strong>Email:</strong> <?= $userDetails['payer_email'] ?>
                                </li>
                                <li class="list-group-item">
                                    <strong>Address:</strong> <?= $userDetails['address'] ?>
                                </li>
                                <li class="list-group-item">
                                    <strong>City:</strong> <?= $userDetails['city'] ?>
                                </li>
                                <li class="list-group-item">
                                    <strong>Country:</strong> <?= $userDetails['country'] ?>
                                </li>
                                <li class="list-group-item">
                                    <strong>Additional info:</strong> <?= $userDetails['description'] ?>
                                </li>
                                <li class="list-group-item">
                                    <strong>Item Name:</strong> <?= $userDetails['item_name'] ?>
                                </li>
                            </ul>
                            <?php
                            if (!$configData) {
                                echo '<div class="alert alert-warning text-center">Unable to load configuration.</div>';
                            } else {
                                //show payment gateway radio button
                                $configItem = $configData['payments']['gateway_configuration'];

                            //show payment gateway radio button
                            foreach ($configItem as $key => $value) {
                                if ($value['enable'] and $key == 'paypal-checkout') { ?>
                                    <div class="form-check form-check-inline">
                                        <label class="form-check-label" for="paymentOption-<?= $key ?>">
                                            <fieldset class="lw-fieldset mr-3 mb-3">
                                                <legend class="lw-fieldset-legend-font">
                                                    <input class="form-check-input" type="radio" required="true" id="paymentOption-<?= $key ?>" name="paymentOption" value="<?= $key ?>">
                                                    <img class="lw-payment-gateway-icon" src="../assets/imgs/payment-images/<?= $key ?>-small.png">
                                                </legend>
                                                <img class="lw-payment-gateway-icon" src="../assets/imgs/payment-images/<?= $key ?>-big.jpg">
                                            </fieldset>
                                        </label>
                                    </div>
                                <?php  }
                            } ?>
                                <h3 id="lwPaymentAmount"></h3>
                                <div class="" id="payPalCheckoutForm">
                                    <div class="mt-3" id="paypal-button-container" style=""></div>
                                </div>
                            <?php } ?>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</body>

</html>

<?php
$paypalClientId = "";
if (configItemData('payments.gateway_configuration.paypal-checkout.testMode')) {
    $paypalClientId = configItemData('payments.gateway_configuration.paypal-checkout.paypalTestingClientKey');
} else {
    $paypalClientId = configItemData('payments.gateway_configuration.paypal-checkout.paypalLiveClientKey');
}

$currency = configItemData('payments.gateway_configuration.paypal-checkout.currency');
$currencySymbol = configItemData('payments.gateway_configuration.paypal-checkout.currencySymbol');

?>



<script type="text/javascript">
    $("#paypal-button-container").addClass("disable-btn");
    var userDetails = <?= json_encode($userDetails) ?>;
    $(document).ready(function() {
        var gatewayCurrency = "<?= $currency ?>",
            currencySymbol = "<?= $currencySymbol ?>",
            formattedAmount = '<hr>' + currencySymbol + ' ' + userDetails['amounts'][gatewayCurrency] + ' ' + gatewayCurrency + '<hr>';
        $('#lwPaymentAmount').html(formattedAmount);
    });
</script>
<?php if (configItemData('payments.gateway_configuration.paypal-checkout.enable')) { ?>
    <script src="https://www.paypal.com/sdk/js?client-id=<?= $paypalClientId ?>&currency=<?= $currency ?>"></script>

    <!-- Jquery Form submit in script tag -->
    <script type="text/javascript">
        $("#payPalCheckoutForm").hide();
        var userDetails = <?= json_encode($userDetails) ?>;
        userDetails['paymentOption'] = 'paypal-checkout';
        $('input[name=paymentOption]').change(function() {
            // Get value of payment option
            var selectedPayment = $('input[name=paymentOption]:checked').val();
            if(selectedPayment != 'paypal-checkout'){
            $("#payPalCheckoutForm").hide();
            $("#paypal-button-container").addClass("disable-btn");
        }else{
            $("#payPalCheckoutForm").show();
            $("#paypal-button-container").removeClass("disable-btn");
        }
        });

        paypal.Buttons({
            createOrder() {
                return fetch('../payment-process.php', {
                        method: "post",
                        headers: {
                            'content-type': 'application/json',
                        },
                        body: JSON.stringify(userDetails),
                    })
                    .then((response) => {
                        return response.json();
                    })
                    .then((order) => {
                        return order.id;
                    });
            },
            // Finalize the transaction on the server after payer approval
            onApprove(responseData) {
                return fetch('../payment-process.php', {
                        method: "post",
                        headers: {
                            'content-type': 'application/json'
                        },
                        body: JSON.stringify({
                            'responseData': responseData,
                            'userDetails': userDetails,
                        })
                    })
                    .then((response) => {
                        return response.json();
                    })
                    .then((orderData) => {
                        if (orderData.status == 'COMPLETED') {
                            //on success load paypalUrl page
                            window.location.href = orderData.successUrl;
                        }
                    });
            },
            onError: function(err) {
                // Show an error page here, when an error occurs
                console.log(err.message);

                //on error show alert message
                alert("AJAX error in request: " + JSON.stringify(err.message, null, 2));
            },
            onCancel: function(oncancel) {
                console.log(oncancel);
            }
        }).render('#paypal-button-container');
    </script>
<?php } ?>
<!-- /  Jquery Form submit in script tag -->